"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.value = exports.values = exports.identifier = exports.fromHeader = exports.fromDocument = void 0;
const F = __importStar(require("fp-ts/function"));
const O = __importStar(require("fp-ts/Option"));
const R = __importStar(require("remeda"));
const Common = __importStar(require("./common"));
const flagSuffixR = /\bflags$/i;
const fromDocument = ($) => $("h6")
    .filter((_, h6) => flagSuffixR.test($(h6).text()))
    .filter((_, el) => Common.hasTable($(el)))
    .map((_, h6) => exports.fromHeader($)($(h6)))
    .toArray();
exports.fromDocument = fromDocument;
const fromHeader = ($) => ($h6) => {
    const $table = Common.table($h6);
    return {
        identifier: exports.identifier($h6.text()),
        values: exports.values($)($table),
    };
};
exports.fromHeader = fromHeader;
const identifier = (heading) => F.pipe(heading.trim(), (text) => text.replace(/bitwise/i, ""), Common.typeify, Common.maybeRename);
exports.identifier = identifier;
const values = ($) => ($table) => {
    const $th = $table.find("th");
    const headerCount = $table.find("th").length;
    const valueIndex = F.pipe(Common.columnIndex(["value", "integer", "id"])($)($th), O.getOrElse(() => 0));
    const nameIndex = valueIndex === 0 ? 1 : 0;
    return F.pipe($table
        .find("td")
        .map((_, td) => $(td))
        .toArray(), R.chunk(headerCount), R.map((values) => exports.value(values[nameIndex], values[valueIndex], values[2])), R.filter(O.isSome), R.map((value) => value.value));
};
exports.values = values;
const value = ($name, $value, $description) => {
    const name = Common.constantify($name.text());
    const value = $value.text();
    const bigint = /x/.test(value);
    return F.pipe(O.fromNullable(value.match(/(\d+) << (\d+)/)), O.map((matches) => ({
        name,
        bigint,
        left: matches[1],
        right: matches[2],
        description: F.pipe(O.fromNullable($description), O.map(($d) => $d.text())),
    })));
};
exports.value = value;
